Index: ide/icon.ico
===================================================================
Nie można wyświetlić: plik binarny.
svn:mime-type = application/octet-stream
Index: ide/ide.iml
===================================================================
--- ide/ide.iml	(wersja 8742)
+++ ide/ide.iml	(kopia robocza)
@@ -100,6 +100,8 @@
 IMAGE_ID(Error)
 IMAGE_ID(Go_forward)
 IMAGE_ID(DownloadBlack)
+IMAGE_ID(AssistGoBack)
+IMAGE_ID(AssistGoForward)
 
 IMAGE_BEGIN_DATA
 IMAGE_DATA(120,156,237,152,141,153,131,32,12,134,29,161,35,220,116,157,163,163,117,179,92,181,141,66,126,72,20,17,84,194,147,167)
@@ -927,45 +929,53 @@
 IMAGE_END_DATA(1952, 17)
 
 IMAGE_BEGIN_DATA
-IMAGE_DATA(120,156,237,151,127,108,83,85,20,199,223,146,57,153,17,6,89,55,236,218,206,17,134,8,254,64,77,230,230,15,24,131)
-IMAGE_DATA(96,160,137,196,63,40,98,209,160,24,51,25,138,108,80,127,16,150,84,3,196,161,40,208,148,48,210,33,195,169,101,67)
-IMAGE_DATA(166,193,56,194,134,161,81,103,194,239,176,13,200,90,214,31,172,108,37,56,148,117,235,186,205,247,245,157,183,190,102,91)
-IMAGE_DATA(223,219,250,58,254,128,192,73,78,94,239,187,231,123,238,231,221,123,222,125,183,204,36,102,34,115,151,152,142,115,200,244)
-IMAGE_DATA(225,6,187,157,1,48,186,215,212,136,230,208,233,116,209,233,201,41,54,196,29,19,3,197,141,196,80,89,57,19,153,153)
-IMAGE_DATA(107,184,113,116,162,237,104,24,40,150,52,164,21,107,143,198,112,59,204,195,88,24,104,157,199,192,192,48,242,107,114,56)
-IMAGE_DATA(195,237,99,247,54,19,121,155,201,67,118,35,212,48,115,190,75,196,205,97,87,212,172,22,45,224,68,221,51,80,113,177)
-IMAGE_DATA(228,201,59,94,69,242,202,57,172,242,250,86,76,214,168,88,85,112,103,56,23,245,83,44,35,82,192,2,3,159,99,249)
-IMAGE_DATA(243,172,162,116,57,82,14,23,64,241,210,44,86,208,170,184,126,138,147,98,160,184,148,154,247,160,84,42,35,253,181,23)
-IMAGE_DATA(162,98,80,133,88,83,255,88,135,148,172,71,248,177,83,178,166,179,169,245,134,176,126,36,6,65,79,227,137,113,16,159)
-IMAGE_DATA(122,84,6,115,56,143,66,251,52,155,82,157,15,197,190,21,72,214,63,199,170,66,107,18,13,3,207,219,103,194,228,135)
-IMAGE_DATA(213,172,210,87,130,228,85,121,172,226,235,165,225,181,146,98,160,117,30,188,238,82,117,33,193,192,48,247,54,147,59,210)
-IMAGE_DATA(110,201,102,98,179,217,224,114,185,34,220,237,118,15,241,242,242,114,209,2,214,106,181,124,188,48,70,92,92,28,171,209)
-IMAGE_DATA(104,88,179,217,12,167,211,25,206,71,191,41,150,17,41,96,98,160,49,232,55,233,90,90,90,80,81,81,129,164,164,36)
-IMAGE_DATA(150,238,11,57,40,78,138,129,242,11,57,40,86,200,145,145,145,17,206,49,26,131,240,220,131,231,44,62,62,158,181,88)
-IMAGE_DATA(44,16,114,140,198,48,56,135,48,166,213,106,69,122,122,58,207,17,13,195,224,28,194,60,82,14,97,62,162,97,16,198)
-IMAGE_DATA(30,244,44,108,90,90,26,107,50,153,248,62,41,6,90,231,225,107,47,86,31,18,12,12,35,175,30,239,250,205,36,150)
-IMAGE_DATA(151,54,34,71,165,90,252,248,72,247,163,204,161,211,77,144,56,194,78,144,181,72,104,156,58,84,79,237,40,25,36,89)
-IMAGE_DATA(100,50,68,176,196,192,16,193,18,35,67,152,69,198,90,72,178,48,183,230,133,25,11,3,89,33,231,149,161,107,44,230)
-IMAGE_DATA(201,201,161,191,141,12,232,74,109,153,122,29,233,6,215,71,40,143,156,121,81,115,142,109,219,6,244,116,101,6,230,69)
-IMAGE_DATA(45,147,37,135,243,250,144,182,62,212,22,183,137,35,109,38,137,211,180,76,134,222,50,62,111,187,47,117,201,62,127,234)
-IMAGE_DATA(146,111,252,227,243,118,248,232,30,223,39,101,113,247,37,50,154,252,163,143,111,180,97,249,17,15,214,55,118,162,216,222)
-IMAGE_DATA(133,98,71,0,134,11,157,252,61,234,163,24,62,118,136,54,126,28,147,245,165,87,127,200,137,173,238,30,108,108,252,7)
-IMAGE_DATA(249,127,182,99,165,237,42,22,31,106,133,254,183,171,48,94,250,23,37,92,159,190,154,251,146,112,177,188,70,176,233,239)
-IMAGE_DATA(31,89,245,171,7,187,188,1,172,56,214,142,69,135,91,145,91,237,193,163,21,110,104,74,237,88,186,191,25,79,84,184)
-IMAGE_DATA(184,124,237,48,121,2,200,231,98,73,195,107,147,30,91,168,221,126,26,230,214,30,204,173,114,226,201,111,157,120,246,59)
-IMAGE_DATA(23,94,180,14,104,201,201,230,238,110,66,246,1,15,150,213,182,97,231,149,32,180,219,79,129,180,9,79,21,148,109,58)
-IMAGE_DATA(211,129,197,135,219,194,241,195,157,44,216,19,196,60,211,57,44,248,233,10,86,159,232,128,241,196,53,144,118,202,91,85)
-IMAGE_DATA(190,79,29,61,200,251,193,137,115,158,155,24,201,58,253,61,200,45,57,137,69,7,61,216,226,238,199,148,55,171,124,51)
-IMAGE_DATA(12,199,2,230,182,94,204,255,222,129,154,134,235,35,234,7,140,197,235,166,83,40,228,24,102,109,56,30,200,254,236,175)
-IMAGE_DATA(64,89,7,144,100,60,11,107,173,39,10,61,48,123,93,29,222,169,243,98,78,201,201,192,76,67,157,111,173,189,31,19)
-IMAGE_DATA(54,156,193,47,181,142,81,148,255,97,234,178,31,145,186,185,9,235,28,253,152,105,168,245,77,212,22,151,173,56,219,141)
-IMAGE_DATA(236,210,75,152,99,56,46,234,100,55,58,186,48,245,21,43,166,151,94,198,234,139,189,88,98,187,1,210,38,164,231,44)
-IMAGE_DATA(212,86,123,177,230,66,0,11,126,110,71,238,65,47,242,14,121,49,175,186,13,153,123,28,188,190,175,55,136,241,179,45)
-IMAGE_DATA(200,57,208,138,181,205,61,248,224,188,31,90,46,134,180,84,2,201,111,236,62,82,112,142,171,215,203,65,20,53,118,161)
-IMAGE_DATA(168,169,11,235,47,6,176,170,161,139,215,79,154,187,23,47,31,251,27,31,59,251,184,186,238,194,187,167,111,66,193,105)
-IMAGE_DATA(194,245,23,159,48,46,115,83,189,183,240,124,39,140,142,110,124,216,228,71,81,3,249,77,254,121,87,158,245,99,243,213)
-IMAGE_DATA(62,24,237,221,40,108,232,196,180,205,245,94,210,12,125,5,238,79,84,22,236,63,170,255,189,3,159,52,119,99,11,87)
-IMAGE_DATA(167,159,115,117,86,114,13,248,234,58,139,143,46,250,65,125,20,67,177,82,175,225,184,25,185,218,244,183,191,176,228,236)
-IMAGE_DATA(109,240,205,171,114,250,231,31,116,249,179,45,141,62,186,71,125,17,130,7,152,7,165,55,3,121,22,245,41,225,14,142)
-IMAGE_DATA(147,115,66,146,115,138,146,115,210,138,249,235,253,63,233,190,168,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
-IMAGE_END_DATA(1312, 6)
+IMAGE_DATA(120,156,237,87,109,76,83,103,20,190,36,76,101,153,162,163,224,144,130,24,113,78,247,225,182,196,209,125,40,162,209,104)
+IMAGE_DATA(147,153,253,176,206,225,140,155,203,194,196,205,137,202,62,140,34,91,212,12,55,55,181,169,145,165,58,117,108,67,112,178)
+IMAGE_DATA(197,5,140,232,82,178,13,227,39,70,64,141,69,11,149,10,53,14,55,41,20,196,221,103,247,92,238,189,246,227,222,182)
+IMAGE_DATA(151,246,135,70,79,114,210,222,247,61,207,115,158,251,158,243,190,125,203,12,99,134,50,247,137,25,56,135,74,247,53,88)
+IMAGE_DATA(173,12,128,224,94,89,41,203,97,48,24,66,195,147,83,172,160,187,95,26,40,46,144,134,210,210,241,72,75,91,202,229)
+IMAGE_DATA(49,200,62,135,162,129,98,9,67,88,185,231,96,26,238,134,117,8,71,3,213,57,12,13,12,163,190,39,125,53,220,61)
+IMAGE_DATA(246,224,48,81,119,152,60,102,45,128,22,38,206,183,201,184,73,114,77,229,18,217,6,142,49,60,143,36,46,150,60,110)
+IMAGE_DATA(203,235,136,91,52,153,77,188,190,17,195,147,147,216,164,158,173,18,23,205,83,44,35,211,192,162,6,158,99,254,75,172)
+IMAGE_DATA(166,104,62,226,15,228,64,51,99,2,43,98,147,184,121,138,83,210,64,113,241,149,239,35,49,49,209,223,223,120,57,36)
+IMAGE_DATA(13,73,130,214,132,63,87,32,126,226,227,124,238,248,137,99,217,132,154,60,9,31,72,131,136,167,124,114,58,72,159,54)
+IMAGE_DATA(168,6,147,196,163,209,63,199,198,151,103,67,179,107,33,226,178,94,100,147,132,154,132,162,129,215,219,107,196,240,145,90)
+IMAGE_DATA(54,209,89,136,184,197,153,172,230,155,185,82,173,148,52,80,157,61,235,174,212,23,10,26,24,230,193,97,114,79,90,68)
+IMAGE_DATA(14,147,234,234,106,52,53,53,249,121,115,115,179,151,239,222,189,91,182,129,245,122,61,31,47,230,136,138,138,98,147,147)
+IMAGE_DATA(147,89,147,201,4,155,205,38,241,209,119,138,101,100,26,152,52,80,14,250,78,184,203,151,47,163,184,184,24,177,177,177)
+IMAGE_DATA(44,141,139,28,20,167,164,129,248,69,14,138,21,57,82,83,83,37,142,96,26,196,247,246,92,179,232,232,104,214,108,54)
+IMAGE_DATA(67,228,8,166,193,147,67,204,89,82,82,130,148,148,20,94,71,40,26,60,57,196,117,36,14,113,61,66,209,32,230,246)
+IMAGE_DATA(120,23,118,196,136,17,172,209,104,228,231,148,52,80,157,125,107,47,215,31,10,26,24,70,93,63,222,247,135,73,127,54)
+IMAGE_DATA(173,31,71,169,86,254,250,72,227,33,114,24,12,67,20,174,176,67,84,21,9,245,163,189,241,244,28,162,6,69,45,42)
+IMAGE_DATA(53,248,105,233,135,6,63,45,253,212,32,105,81,81,11,69,45,76,100,54,76,56,26,200,114,57,47,21,62,251,99,118)
+IMAGE_DATA(157,142,254,54,50,160,79,122,86,137,55,16,206,179,63,4,30,53,235,162,229,28,155,54,245,225,233,147,233,91,23,173)
+IMAGE_DATA(74,45,58,206,107,4,108,141,240,44,111,67,3,29,38,49,99,244,76,106,150,121,112,230,102,103,194,156,93,174,132,57)
+IMAGE_DATA(223,185,6,103,110,113,210,24,63,167,100,81,15,197,48,201,217,135,158,90,93,141,249,7,237,88,89,223,129,53,214,78)
+IMAGE_DATA(172,105,116,35,239,92,7,63,70,115,20,195,199,122,97,163,7,49,19,191,114,100,237,183,97,99,115,55,86,215,255,131)
+IMAGE_DATA(236,191,218,176,168,250,42,102,239,111,65,214,239,87,81,112,225,95,20,114,115,89,229,220,47,9,23,203,99,68,27,251)
+IMAGE_DATA(193,193,197,21,118,108,115,184,177,240,72,27,102,29,104,65,70,185,29,79,20,55,35,185,200,138,185,123,46,226,233,226)
+IMAGE_DATA(38,142,175,13,70,187,27,217,92,44,97,120,108,236,147,51,245,155,79,193,212,210,141,41,101,54,60,243,189,13,47,252)
+IMAGE_DATA(208,132,87,74,250,176,228,100,83,182,55,32,125,175,29,243,170,90,177,245,74,15,244,155,79,130,176,3,158,205,217,177)
+IMAGE_DATA(238,116,59,102,31,104,149,226,125,157,172,167,187,7,83,141,103,48,253,151,43,88,114,188,29,5,199,175,129,176,163,222)
+IMAGE_DATA(46,115,126,214,216,141,204,159,108,56,99,191,137,64,214,225,234,70,70,225,9,204,218,103,199,134,230,219,24,245,86,153)
+IMAGE_DATA(115,92,222,17,183,169,245,22,166,253,216,136,202,186,235,1,241,125,198,226,77,227,73,228,114,26,38,172,178,184,211,63)
+IMAGE_DATA(63,234,222,209,14,196,22,212,162,164,202,30,2,30,152,180,226,48,222,61,236,192,228,194,19,238,241,121,135,157,203,172)
+IMAGE_DATA(183,49,100,213,105,252,86,213,24,4,249,31,70,207,251,25,9,235,27,176,162,241,54,198,231,85,57,135,234,215,236,88)
+IMAGE_DATA(88,219,133,244,162,11,152,156,103,145,117,178,27,237,157,24,253,90,9,198,22,93,194,146,243,183,48,167,250,6,8,59)
+IMAGE_DATA(32,69,55,83,95,238,192,210,115,110,76,255,181,13,25,251,28,200,220,239,192,212,242,86,164,125,219,200,227,123,111,245)
+IMAGE_DATA(96,240,36,51,116,123,91,176,236,98,55,62,60,235,130,158,139,33,44,181,64,220,130,237,7,115,206,112,253,122,169,7)
+IMAGE_DATA(203,235,59,177,188,161,19,43,207,187,177,184,174,147,199,15,155,178,19,175,30,249,27,159,216,122,185,190,238,196,123,167)
+IMAGE_DATA(110,66,195,97,164,254,139,30,48,40,109,93,141,35,247,108,7,10,26,187,240,81,131,11,203,235,200,111,242,239,187,168)
+IMAGE_DATA(214,133,245,87,123,81,96,237,66,110,93,7,198,172,175,113,16,198,123,11,12,140,73,204,217,115,40,235,143,118,124,122)
+IMAGE_DATA(177,11,27,184,62,253,130,235,179,194,107,192,215,215,89,124,124,222,5,154,163,24,138,85,218,134,131,198,101,232,83,222)
+IMAGE_DATA(249,210,172,219,89,231,156,90,102,115,77,219,215,228,74,55,215,59,105,140,230,252,0,15,51,143,40,31,6,234,44,228)
+IMAGE_DATA(91,194,61,28,167,230,134,164,230,22,165,230,166,213,255,95,239,128,39,63,103,3,71,50,25,218,181,12,60,157,198,130)
+IMAGE_DATA(241,74,184,45,156,91,56,63,38,184,69,24,11,192,195,99,125,113,190,46,240,248,114,72,216,10,33,174,66,200,151,47)
+IMAGE_DATA(195,81,225,207,193,107,182,220,153,215,109,31,137,163,54,75,223,187,43,233,88,219,183,248,82,110,31,44,153,34,254,216)
+IMAGE_DATA(29,13,82,110,139,55,150,199,231,123,215,128,247,124,111,13,82,14,142,239,202,13,91,208,83,219,75,83,164,240,97,232)
+IMAGE_DATA(15,119,253,194,173,95,36,250,39,220,254,141,196,254,145,229,9,101,255,6,59,12,30,93,192,212,250,146,209,88,48,17)
+IMAGE_DATA(18,46,192,203,40,241,240,216,16,23,211,151,67,194,86,200,96,242,133,220,62,133,246,228,240,106,38,95,231,230,168,177)
+IMAGE_DATA(168,193,36,14,143,102,146,114,43,105,94,203,240,141,237,199,33,104,240,202,173,176,121,68,147,56,44,140,255,97,224,145)
+IMAGE_DATA(43,144,209,134,151,244,70,10,31,134,254,112,215,47,220,250,69,162,127,194,237,223,72,236,31,89,158,16,246,239,255,6)
+IMAGE_DATA(177,225,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
+IMAGE_END_DATA(1568, 8)
Index: ide/idebar.cpp
===================================================================
--- ide/idebar.cpp	(wersja 8742)
+++ ide/idebar.cpp	(kopia robocza)
@@ -70,10 +70,6 @@
 		    .Help("Close the current file tab");
 		menu.Add(AK_CLOSETABS, THISBACK(ClearTabs))
 		    .Help("Close all file tabs");
-		menu.Add("Go back", THISBACK(HistoryBk))
-		    .Key(K_ALT_LEFT);
-		menu.Add("Go forward", THISBACK(HistoryFw))
-		    .Key(K_ALT_RIGHT);
 		if(!designer) {
 			menu.Add("Bookmarks", THISBACK(FileBookmark))
 				.Help("Set one of available bookmarks (1..9, 0) on current file");
@@ -582,8 +578,8 @@
 
 void Ide::BrowseMenu(Bar& menu)
 {
-	if (menu.IsMenuBar()) {
-		if(!IsEditorMode()) {
+	if(!IsEditorMode()) {
+		if(menu.IsMenuBar()) {
 			menu.AddMenu(AK_NAVIGATOR, IdeImg::Navigator(), THISBACK(ToggleNavigator))
 		    	 .Check(editor.IsNavigator());
 			menu.Add(AK_GOTO, THISBACK(SearchCode));
@@ -598,10 +594,24 @@
 			menu.Add(!designer, AK_ABBR, callback(&editor, &AssistEditor::Abbr));
 			menu.Add(!designer, "Insert", THISBACK(InsertMenu));
 			menu.MenuSeparator();
+		}
+		
+		menu.Add("Go back", IdeImg::AssistGoBack(), THISBACK(HistoryBk))
+	    	.Key(K_ALT_LEFT)
+	    	.Enable(histi > 0);
+		menu.Add("Go forward", IdeImg::AssistGoForward(), THISBACK(HistoryFw))
+	    	.Key(K_ALT_RIGHT)
+	    	.Enable(histi < history.GetCount() - 1);
+		
+		if(menu.IsMenuBar()) {
+			menu.MenuSeparator();
 			menu.Add("Check source files for changes", THISBACK(CheckCodeBase));
 			menu.Add("Reparse source files", THISBACK(RescanCode));
 			menu.MenuSeparator();
 		}
+		
+	}
+	if(menu.IsMenuBar()) {
 		menu.AddMenu(AK_CALC, IdeImg::calc(), THISBACK1(ToggleBottom, BCALC))
 	     .Check(IsBottomShown() && btabs.GetCursor() == BCALC);
 		menu.AddMenu(AK_QTF, IdeCommonImg::Qtf(), THISBACK(Qtf));
@@ -651,6 +661,11 @@
 
 void Ide::MainTool(Bar& bar)
 {
+	if(!IsEditorMode()) {
+		BrowseMenu(bar);
+		if(!toolbar_in_row)
+			bar.Separator();
+	}
 	Edit(bar);
 	if(debugger) {
 		if(!designer)
@@ -667,7 +682,6 @@
 		DebugMenu(bar);
 	}
 	Setup(bar);
-	BrowseMenu(bar);
 	bar.Separator();
 	HelpMenu(bar);
 }