Index: ide/icon.ico
===================================================================
Nie można wyświetlić: plik binarny.
svn:mime-type = application/octet-stream
Index: ide/ide.iml
===================================================================
--- ide/ide.iml	(wersja 8764)
+++ ide/ide.iml	(kopia robocza)
@@ -102,6 +102,8 @@
 IMAGE_ID(DownloadBlack)
 IMAGE_ID(AssistGoBack)
 IMAGE_ID(AssistGoForward)
+IMAGE_ID(EditAsText)
+IMAGE_ID(EditInDesigner)
 
 IMAGE_BEGIN_DATA
 IMAGE_DATA(120,156,237,152,141,153,131,32,12,134,29,161,35,220,116,157,163,163,117,179,92,181,141,66,126,72,20,17,84,194,147,167)
@@ -929,53 +931,79 @@
 IMAGE_END_DATA(1952, 17)
 
 IMAGE_BEGIN_DATA
-IMAGE_DATA(120,156,237,87,109,76,83,103,20,190,36,76,101,153,162,163,224,144,130,24,113,78,247,225,182,196,209,125,40,162,209,104)
-IMAGE_DATA(147,153,253,176,206,225,140,155,203,194,196,205,137,202,62,140,34,91,212,12,55,55,181,169,145,165,58,117,108,67,112,178)
-IMAGE_DATA(197,5,140,232,82,178,13,227,39,70,64,141,69,11,149,10,53,14,55,41,20,196,221,103,247,92,238,189,246,227,222,182)
-IMAGE_DATA(151,246,135,70,79,114,210,222,247,61,207,115,158,251,158,243,190,125,203,12,99,134,50,247,137,25,56,135,74,247,53,88)
-IMAGE_DATA(173,12,128,224,94,89,41,203,97,48,24,66,195,147,83,172,160,187,95,26,40,46,144,134,210,210,241,72,75,91,202,229)
-IMAGE_DATA(49,200,62,135,162,129,98,9,67,88,185,231,96,26,238,134,117,8,71,3,213,57,12,13,12,163,190,39,125,53,220,61)
-IMAGE_DATA(246,224,48,81,119,152,60,102,45,128,22,38,206,183,201,184,73,114,77,229,18,217,6,142,49,60,143,36,46,150,60,110)
-IMAGE_DATA(203,235,136,91,52,153,77,188,190,17,195,147,147,216,164,158,173,18,23,205,83,44,35,211,192,162,6,158,99,254,75,172)
-IMAGE_DATA(166,104,62,226,15,228,64,51,99,2,43,98,147,184,121,138,83,210,64,113,241,149,239,35,49,49,209,223,223,120,57,36)
-IMAGE_DATA(13,73,130,214,132,63,87,32,126,226,227,124,238,248,137,99,217,132,154,60,9,31,72,131,136,167,124,114,58,72,159,54)
-IMAGE_DATA(168,6,147,196,163,209,63,199,198,151,103,67,179,107,33,226,178,94,100,147,132,154,132,162,129,215,219,107,196,240,145,90)
-IMAGE_DATA(54,209,89,136,184,197,153,172,230,155,185,82,173,148,52,80,157,61,235,174,212,23,10,26,24,230,193,97,114,79,90,68)
-IMAGE_DATA(14,147,234,234,106,52,53,53,249,121,115,115,179,151,239,222,189,91,182,129,245,122,61,31,47,230,136,138,138,98,147,147)
-IMAGE_DATA(147,89,147,201,4,155,205,38,241,209,119,138,101,100,26,152,52,80,14,250,78,184,203,151,47,163,184,184,24,177,177,177)
-IMAGE_DATA(44,141,139,28,20,167,164,129,248,69,14,138,21,57,82,83,83,37,142,96,26,196,247,246,92,179,232,232,104,214,108,54)
-IMAGE_DATA(67,228,8,166,193,147,67,204,89,82,82,130,148,148,20,94,71,40,26,60,57,196,117,36,14,113,61,66,209,32,230,246)
-IMAGE_DATA(120,23,118,196,136,17,172,209,104,228,231,148,52,80,157,125,107,47,215,31,10,26,24,70,93,63,222,247,135,73,127,54)
-IMAGE_DATA(173,31,71,169,86,254,250,72,227,33,114,24,12,67,20,174,176,67,84,21,9,245,163,189,241,244,28,162,6,69,45,42)
-IMAGE_DATA(53,248,105,233,135,6,63,45,253,212,32,105,81,81,11,69,45,76,100,54,76,56,26,200,114,57,47,21,62,251,99,118)
-IMAGE_DATA(157,142,254,54,50,160,79,122,86,137,55,16,206,179,63,4,30,53,235,162,229,28,155,54,245,225,233,147,233,91,23,173)
-IMAGE_DATA(74,45,58,206,107,4,108,141,240,44,111,67,3,29,38,49,99,244,76,106,150,121,112,230,102,103,194,156,93,174,132,57)
-IMAGE_DATA(223,185,6,103,110,113,210,24,63,167,100,81,15,197,48,201,217,135,158,90,93,141,249,7,237,88,89,223,129,53,214,78)
-IMAGE_DATA(172,105,116,35,239,92,7,63,70,115,20,195,199,122,97,163,7,49,19,191,114,100,237,183,97,99,115,55,86,215,255,131)
-IMAGE_DATA(236,191,218,176,168,250,42,102,239,111,65,214,239,87,81,112,225,95,20,114,115,89,229,220,47,9,23,203,99,68,27,251)
-IMAGE_DATA(193,193,197,21,118,108,115,184,177,240,72,27,102,29,104,65,70,185,29,79,20,55,35,185,200,138,185,123,46,226,233,226)
-IMAGE_DATA(38,142,175,13,70,187,27,217,92,44,97,120,108,236,147,51,245,155,79,193,212,210,141,41,101,54,60,243,189,13,47,252)
-IMAGE_DATA(208,132,87,74,250,176,228,100,83,182,55,32,125,175,29,243,170,90,177,245,74,15,244,155,79,130,176,3,158,205,217,177)
-IMAGE_DATA(238,116,59,102,31,104,149,226,125,157,172,167,187,7,83,141,103,48,253,151,43,88,114,188,29,5,199,175,129,176,163,222)
-IMAGE_DATA(46,115,126,214,216,141,204,159,108,56,99,191,137,64,214,225,234,70,70,225,9,204,218,103,199,134,230,219,24,245,86,153)
-IMAGE_DATA(115,92,222,17,183,169,245,22,166,253,216,136,202,186,235,1,241,125,198,226,77,227,73,228,114,26,38,172,178,184,211,63)
-IMAGE_DATA(63,234,222,209,14,196,22,212,162,164,202,30,2,30,152,180,226,48,222,61,236,192,228,194,19,238,241,121,135,157,203,172)
-IMAGE_DATA(183,49,100,213,105,252,86,213,24,4,249,31,70,207,251,25,9,235,27,176,162,241,54,198,231,85,57,135,234,215,236,88)
-IMAGE_DATA(88,219,133,244,162,11,152,156,103,145,117,178,27,237,157,24,253,90,9,198,22,93,194,146,243,183,48,167,250,6,8,59)
-IMAGE_DATA(32,69,55,83,95,238,192,210,115,110,76,255,181,13,25,251,28,200,220,239,192,212,242,86,164,125,219,200,227,123,111,245)
-IMAGE_DATA(96,240,36,51,116,123,91,176,236,98,55,62,60,235,130,158,139,33,44,181,64,220,130,237,7,115,206,112,253,122,169,7)
-IMAGE_DATA(203,235,59,177,188,161,19,43,207,187,177,184,174,147,199,15,155,178,19,175,30,249,27,159,216,122,185,190,238,196,123,167)
-IMAGE_DATA(110,66,195,97,164,254,139,30,48,40,109,93,141,35,247,108,7,10,26,187,240,81,131,11,203,235,200,111,242,239,187,168)
-IMAGE_DATA(214,133,245,87,123,81,96,237,66,110,93,7,198,172,175,113,16,198,123,11,12,140,73,204,217,115,40,235,143,118,124,122)
-IMAGE_DATA(177,11,27,184,62,253,130,235,179,194,107,192,215,215,89,124,124,222,5,154,163,24,138,85,218,134,131,198,101,232,83,222)
-IMAGE_DATA(249,210,172,219,89,231,156,90,102,115,77,219,215,228,74,55,215,59,105,140,230,252,0,15,51,143,40,31,6,234,44,228)
-IMAGE_DATA(91,194,61,28,167,230,134,164,230,22,165,230,166,213,255,95,239,128,39,63,103,3,71,50,25,218,181,12,60,157,198,130)
-IMAGE_DATA(241,74,184,45,156,91,56,63,38,184,69,24,11,192,195,99,125,113,190,46,240,248,114,72,216,10,33,174,66,200,151,47)
-IMAGE_DATA(195,81,225,207,193,107,182,220,153,215,109,31,137,163,54,75,223,187,43,233,88,219,183,248,82,110,31,44,153,34,254,216)
-IMAGE_DATA(29,13,82,110,139,55,150,199,231,123,215,128,247,124,111,13,82,14,142,239,202,13,91,208,83,219,75,83,164,240,97,232)
-IMAGE_DATA(15,119,253,194,173,95,36,250,39,220,254,141,196,254,145,229,9,101,255,6,59,12,30,93,192,212,250,146,209,88,48,17)
-IMAGE_DATA(18,46,192,203,40,241,240,216,16,23,211,151,67,194,86,200,96,242,133,220,62,133,246,228,240,106,38,95,231,230,168,177)
-IMAGE_DATA(168,193,36,14,143,102,146,114,43,105,94,203,240,141,237,199,33,104,240,202,173,176,121,68,147,56,44,140,255,97,224,145)
-IMAGE_DATA(43,144,209,134,151,244,70,10,31,134,254,112,215,47,220,250,69,162,127,194,237,223,72,236,31,89,158,16,246,239,255,6)
-IMAGE_DATA(177,225,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
-IMAGE_END_DATA(1568, 8)
+IMAGE_DATA(120,156,237,87,107,84,84,215,21,190,164,212,71,43,162,17,136,8,40,89,190,26,211,38,105,173,74,219,248,64,87,82)
+IMAGE_DATA(37,214,38,89,96,45,70,77,52,93,198,87,18,52,104,98,125,144,46,73,68,141,130,148,68,41,152,104,48,33,72,160)
+IMAGE_DATA(190,192,2,186,192,7,44,4,145,0,3,200,107,96,96,24,6,134,97,222,15,192,249,122,207,101,230,102,102,184,243,2)
+IMAGE_DATA(126,196,149,236,181,246,154,185,231,236,239,219,223,57,103,159,61,119,168,137,212,4,234,71,98,97,180,195,69,183,54,212)
+IMAGE_DATA(215,83,0,28,123,118,54,39,71,88,88,152,115,120,226,36,214,168,123,72,26,72,156,61,13,105,105,115,48,99,198,219)
+IMAGE_DATA(116,158,48,206,103,103,52,144,88,130,33,88,174,103,71,26,126,8,251,48,28,13,228,156,135,161,129,162,92,175,73,107)
+IMAGE_DATA(13,63,28,251,169,153,184,214,76,38,215,71,193,31,9,180,127,202,225,9,172,123,101,111,227,44,224,177,97,191,131,31)
+IMAGE_DATA(29,75,124,82,220,223,48,105,227,34,131,175,228,8,158,8,240,51,248,233,79,178,92,100,158,196,82,28,5,108,210,192)
+IMAGE_DATA(112,172,253,163,193,235,244,90,120,95,222,10,175,23,159,53,152,176,126,244,60,137,179,165,129,196,121,103,111,135,175,175)
+IMAGE_DATA(239,96,255,251,159,156,210,224,103,212,234,115,123,23,188,231,205,98,114,123,207,155,109,240,41,140,100,241,246,52,152,240)
+IMAGE_DATA(36,31,151,14,162,207,223,161,134,4,150,199,43,228,183,6,239,204,205,240,250,98,3,38,133,255,193,224,103,60,19,103)
+IMAGE_DATA(52,48,122,251,226,241,196,52,127,131,175,56,6,147,182,4,27,188,78,172,102,207,202,150,6,114,206,230,231,110,171,46)
+IMAGE_DATA(108,104,160,168,159,154,201,35,105,35,210,76,10,10,10,208,220,220,60,200,91,90,90,44,252,236,217,179,156,5,28,18)
+IMAGE_DATA(18,194,196,155,114,184,185,185,25,2,2,2,12,9,9,9,224,243,249,44,31,249,78,98,41,142,2,38,26,72,14,242)
+IMAGE_DATA(157,224,154,154,154,144,146,146,2,79,79,79,3,25,55,113,144,56,91,26,8,191,137,131,196,154,56,2,3,3,89,14)
+IMAGE_DATA(71,26,76,235,54,223,51,119,119,119,67,82,82,18,76,28,142,52,152,115,152,114,166,166,166,98,234,212,169,140,14,103)
+IMAGE_DATA(52,152,115,152,246,145,112,152,246,195,25,13,166,220,102,107,49,76,153,50,197,16,31,31,207,204,217,210,64,206,217,250)
+IMAGE_DATA(236,185,234,195,134,6,138,114,173,30,127,244,205,100,40,151,118,16,71,154,63,247,235,35,25,119,146,35,44,108,188,141)
+IMAGE_DATA(87,216,241,46,29,18,170,166,91,226,201,179,147,26,108,106,113,81,195,32,45,67,208,48,72,203,16,53,176,90,92,56)
+IMAGE_DATA(11,155,90,168,145,185,48,195,209,64,44,130,246,52,227,231,80,76,16,20,68,254,54,82,32,159,228,217,69,124,24,193)
+IMAGE_DATA(153,215,135,145,199,149,125,241,167,29,159,124,50,128,39,159,212,192,190,248,187,168,37,136,246,66,35,182,208,248,204,109)
+IMAGE_DATA(19,236,53,147,177,51,67,168,192,240,36,143,224,88,177,79,232,23,42,159,208,207,85,30,193,113,98,50,198,204,217,50)
+IMAGE_DATA(183,159,143,165,2,54,231,252,122,95,1,214,94,19,224,189,42,37,246,215,171,177,191,65,139,200,106,37,51,70,230,72)
+IMAGE_DATA(12,19,107,129,117,31,67,205,59,38,12,207,224,227,72,139,14,251,170,100,216,124,167,3,27,11,218,177,42,163,13,225)
+IMAGE_DATA(55,218,17,85,43,71,12,61,23,158,73,255,146,208,177,12,198,100,179,119,92,219,146,37,192,167,66,45,54,92,239,192)
+IMAGE_DATA(138,203,109,88,156,41,192,175,82,90,16,112,186,30,171,207,213,225,55,41,205,52,95,7,226,5,90,108,166,99,9,134)
+IMAGE_DATA(193,122,62,189,60,36,246,30,18,218,116,88,114,129,143,103,190,228,99,254,249,102,60,159,58,128,37,78,108,201,41,30)
+IMAGE_DATA(22,124,35,192,154,92,17,78,182,234,17,18,91,10,130,29,245,220,214,228,67,101,82,172,186,44,98,227,173,157,152,94)
+IMAGE_DATA(167,199,210,248,114,188,240,223,86,108,187,43,69,212,221,78,16,236,147,111,92,16,127,216,160,67,240,215,124,148,11,20)
+IMAGE_DATA(176,103,74,149,14,139,99,74,176,34,93,128,143,90,250,241,228,235,23,196,79,69,94,215,38,136,122,177,236,171,6,100)
+IMAGE_DATA(87,74,236,226,7,204,128,215,226,75,17,65,107,120,118,111,190,118,193,191,138,180,201,82,192,51,234,62,82,115,5,78)
+IMAGE_DATA(224,129,133,187,242,240,143,60,33,22,197,148,104,231,68,230,137,223,173,239,199,248,189,101,184,146,219,224,0,249,16,211)
+IMAGE_DATA(215,124,11,159,104,30,118,53,244,99,78,100,174,120,66,200,254,228,13,247,53,88,112,186,22,139,34,243,57,157,88,143)
+IMAGE_DATA(84,141,233,47,167,98,246,233,70,108,171,233,69,104,65,15,8,118,212,212,160,229,33,153,66,188,93,173,197,11,23,59)
+IMAGE_DATA(176,56,93,136,224,12,33,150,102,138,48,35,177,129,193,247,245,234,225,177,48,9,65,223,180,225,221,58,29,222,169,80)
+IMAGE_DATA(33,132,142,33,88,82,2,147,214,157,186,182,181,156,174,215,70,61,118,86,169,177,147,167,198,123,53,90,108,169,84,51)
+IMAGE_DATA(248,137,75,206,224,47,215,187,241,62,191,143,174,107,53,222,186,167,128,23,141,97,235,207,125,212,152,25,135,10,133,17)
+IMAGE_DATA(21,74,68,53,104,176,155,167,194,206,74,226,10,102,189,27,239,171,16,221,222,135,168,122,13,34,42,149,152,25,93,40)
+IMAGE_DATA(36,24,203,43,48,122,172,239,214,115,57,225,183,164,248,160,78,131,143,232,58,61,76,215,89,76,39,112,92,98,192,158)
+IMAGE_DATA(26,21,200,28,137,33,177,182,174,225,152,167,22,135,76,221,116,52,41,232,76,165,120,233,5,190,106,89,122,179,106,65)
+IMAGE_DATA(82,149,152,140,145,185,65,128,95,80,227,108,55,3,215,204,233,183,132,71,56,206,149,55,36,87,222,162,92,121,211,26)
+IMAGE_DATA(250,175,183,221,206,79,219,232,105,212,98,255,131,20,204,157,140,57,226,101,113,113,180,231,211,94,108,244,124,227,152,29)
+IMAGE_DATA(30,6,107,141,179,118,35,143,53,7,139,205,50,198,101,25,243,29,224,224,200,26,204,193,104,206,255,126,62,232,212,52)
+IMAGE_DATA(20,241,243,7,214,110,75,199,193,129,205,103,115,91,97,137,217,196,23,127,175,129,205,157,111,137,101,240,7,44,207,128)
+IMAGE_DATA(241,3,150,26,216,28,52,95,107,15,223,97,215,182,208,52,82,248,97,232,31,238,254,13,247,252,70,162,126,134,91,191)
+IMAGE_DATA(35,113,127,56,121,156,185,191,142,154,193,227,235,168,251,214,100,100,204,145,8,22,103,103,49,182,120,24,172,147,155,105)
+IMAGE_DATA(205,193,98,179,56,48,7,140,185,173,14,218,156,195,162,152,172,157,158,35,133,69,10,140,229,48,43,38,54,183,45,205)
+IMAGE_DATA(7,41,166,176,7,113,24,53,88,228,182,113,121,76,198,114,228,83,131,155,129,89,46,123,70,46,60,171,119,164,240,195)
+IMAGE_DATA(208,63,220,253,27,238,249,141,68,253,12,183,126,71,226,254,112,242,56,115,127,57,154,1,249,3,58,151,246,249,14,60)
+IMAGE_DATA(144,246,199,56,40,231,138,197,98,153,94,175,127,216,223,223,15,46,215,233,116,8,13,13,141,179,193,49,159,96,85,42)
+IMAGE_DATA(21,212,106,53,235,114,185,28,61,61,61,160,185,25,142,54,94,58,106,207,175,65,253,197,104,148,39,191,136,149,243,61)
+IMAGE_DATA(215,211,88,55,130,39,243,90,173,22,52,15,243,73,92,169,84,66,38,147,161,179,179,19,202,182,76,136,110,236,129,172)
+IMAGE_DATA(226,10,253,231,74,136,158,138,116,92,61,24,220,97,142,39,88,147,19,188,70,163,129,66,161,64,199,131,84,72,171,63)
+IMAGE_DATA(132,190,245,18,68,249,71,161,169,204,64,127,243,109,148,38,110,212,154,227,251,250,250,216,245,146,239,100,205,178,214,28)
+IMAGE_DATA(72,171,246,227,161,230,54,52,141,219,209,125,119,7,106,190,220,132,155,177,171,101,1,222,227,102,155,227,173,93,33,188)
+IMAGE_DATA(14,105,229,7,120,168,45,130,186,97,3,180,130,181,80,84,239,133,224,220,43,152,53,101,220,107,70,44,39,94,88,69)
+IMAGE_DATA(175,183,100,143,17,187,30,218,150,112,200,171,254,137,198,196,151,160,22,86,193,120,158,156,120,33,239,18,106,114,118,211)
+IMAGE_DATA(154,111,66,203,223,4,157,96,29,100,180,142,134,83,43,160,16,55,49,49,182,240,53,183,206,131,151,181,23,223,101,199)
+IMAGE_DATA(162,173,56,12,106,254,90,116,151,191,143,198,228,87,160,238,226,51,123,98,15,159,22,179,12,80,52,163,54,49,20,55)
+IMAGE_DATA(246,78,193,29,58,103,209,241,229,80,182,215,50,88,71,248,232,205,207,64,95,244,111,232,139,227,80,28,29,140,140,109)
+IMAGE_DATA(179,32,21,84,161,183,183,151,117,123,248,240,101,147,17,243,198,211,184,113,100,37,74,82,223,129,92,220,204,156,165,185)
+IMAGE_DATA(115,225,233,113,131,173,218,183,118,90,195,67,35,222,100,191,167,235,92,77,198,157,193,118,119,119,43,141,247,213,100,1)
+IMAGE_DATA(132,195,137,251,107,242,185,70,204,160,102,240,72,52,2,145,72,196,114,76,244,112,243,141,219,61,51,107,235,171,30,39)
+IMAGE_DATA(172,27,129,90,163,133,76,109,217,8,200,60,185,216,36,199,198,245,127,77,206,252,207,235,21,242,214,20,92,61,26,168)
+IMAGE_DATA(54,111,4,173,114,45,202,58,52,184,219,174,66,187,92,205,52,130,174,174,46,118,29,26,121,43,90,74,79,64,43,185)
+IMAGE_DATA(132,242,11,11,241,230,159,199,197,153,55,2,158,68,135,219,66,13,110,181,170,80,38,82,177,235,144,72,36,104,23,240)
+IMAGE_DATA(208,88,116,24,250,158,171,16,149,174,195,182,149,30,137,238,143,81,163,204,11,177,169,71,135,156,102,37,254,199,87,224)
+IMAGE_DATA(158,72,205,236,27,225,144,136,106,208,84,28,3,157,244,50,196,223,109,192,199,155,38,151,254,114,180,219,227,166,253,51)
+IMAGE_DATA(225,27,164,90,92,124,208,131,204,90,41,58,148,122,70,147,92,82,7,126,241,49,6,43,169,126,19,249,159,45,130,143)
+IMAGE_DATA(231,207,94,53,22,177,5,62,175,73,134,212,138,46,100,86,75,208,45,233,0,175,236,26,30,228,172,167,53,103,64,222)
+IMAGE_DATA(176,29,215,227,158,67,39,255,190,249,69,96,241,117,18,13,206,149,117,224,204,221,118,92,43,46,69,222,213,84,100,101)
+IMAGE_DATA(158,66,110,242,203,168,203,90,138,146,243,207,163,177,244,146,245,69,98,241,247,132,10,156,46,20,224,68,86,9,142,157)
+IMAGE_DATA(253,22,121,183,239,160,189,181,12,165,119,210,112,49,118,21,120,55,18,185,26,1,139,239,82,234,104,236,61,68,159,187)
+IMAGE_DATA(130,147,87,43,112,232,235,18,172,137,46,64,196,241,43,16,183,55,219,106,4,22,235,143,56,242,57,118,196,164,224,173)
+IMAGE_DATA(195,233,88,183,239,43,236,56,154,139,155,165,245,246,26,1,131,127,100,27,1,109,255,7,221,13,200,4,0,0,0,0)
+IMAGE_END_DATA(2400, 10)
Index: ide/idebar.cpp
===================================================================
--- ide/idebar.cpp	(wersja 8764)
+++ ide/idebar.cpp	(kopia robocza)
@@ -179,11 +179,10 @@
 	if(editfile.GetCount() && editashex.Find(editfile) < 0)
 		menu.Add(AK_EDITASHEX, THISBACK(EditAsHex));
 	if(designer) {
-		if(FileExists(designer->GetFileName())) {
-			menu.Add(AK_EDITASTEXT, THISBACK(EditAsText))
-			    .Help("Edit as text file (do not use a designer)");
-			menu.MenuSeparator();
-		}
+		menu.Add(AK_EDITASTEXT, IdeImg::EditAsText(), THISBACK(EditAsText))
+			.Enable(FileExists(designer->GetFileName()))
+		    .Help("Edit as text file (do not use a designer)");
+		menu.Separator();
 		if(menu.IsMenuBar())
 			designer->EditMenu(menu);
 	}
@@ -199,12 +198,11 @@
 				    .Help("Edit raw strings");
 			menu.MenuSeparator();
 		}
-		else
-		if(editastext.Find(editfile) >= 0) {
-			menu.Add(AK_DESIGNER, THISBACK(EditUsingDesigner))
-			    .Help("Edit using the designer (not as text)");
-			menu.MenuSeparator();
-		}
+		menu.Add(AK_DESIGNER, IdeImg::EditInDesigner(), THISBACK(EditUsingDesigner))
+			.Enable(editastext.Find(editfile) >= 0)
+		    .Help("Edit using the designer (not as text)");
+		if(!toolbar_in_row)
+			menu.Separator();
 		Bar::Item& (Bar::*add)(const char *s, const Image& m, Callback cb) = &Bar::Add;
 		if(toolbar_in_row) add = &MenuBar::AddMenu;
 		(menu.*add)("Undo", CtrlImg::undo(), callback(&editor, &LineEdit::Undo))
@@ -663,8 +661,7 @@
 {
 	if(!IsEditorMode()) {
 		BrowseMenu(bar);
-		if(!toolbar_in_row)
-			bar.Separator();
+		bar.Separator();
 	}
 	Edit(bar);
 	if(debugger) {
Index: ide/idefile.cpp
===================================================================
--- ide/idefile.cpp	(wersja 8764)
+++ ide/idefile.cpp	(kopia robocza)
@@ -630,6 +630,8 @@
 	byte cs = editor.GetCharset();
 	FlushFile();
 	EditFile0(path, cs);
+	
+	SetToolBar();
 }
 
 void Ide::EditUsingDesigner()
@@ -640,6 +642,8 @@
 	byte cs = editor.GetCharset();
 	FlushFile();
 	EditFile0(path, cs);
+	
+	SetToolBar();
 }
 
 void Ide::AddEditFile(const String& path)
Index: upt/AndroidSDK.upt
===================================================================
--- upt/AndroidSDK.upt	(wersja 8764)
+++ upt/AndroidSDK.upt	(kopia robocza)
@@ -26,14 +26,14 @@
 <?xml version="1.0" encoding="utf-8"?>
 <manifest xmlns:android="http://schemas.android.com/apk/res/android"
           package="org.upp.<:PACKAGE:>">
-    <application>
-        <activity android:name=".<:PACKAGE:>"
-                  android:label="<:PACKAGE:>">
-            <intent-filter>
-                <action android:name="android.intent.action.MAIN" />
-                <category android:name="android.intent.category.LAUNCHER" />
-            </intent-filter>
-        </activity>
+	<application>
+		<activity android:name=".<:PACKAGE:>"
+		          android:label="<:PACKAGE:>">
+			<intent-filter>
+				<action android:name="android.intent.action.MAIN" />
+				<category android:name="android.intent.category.LAUNCHER" />
+			</intent-filter>
+		</activity>
 	</application>
 </manifest>
 @@<:PACKAGE:>.upp